<?php

  if( ! defined( 'IN_PLAYLIST'))
  {
    die( 'not supposed to be here ...');
  }

  // //////////////////////////////////////////////////////////////////////////

  // functions

  function bh_debug( $msg, $comment = '')
  {
    global $bh_debug;

    if( $bh_debug)
    {
      print( "<table><tr>");
      if( $comment != '')
        print( "<td width=\"200\">$comment</td>");
      print( "<td>");
      var_dump( $msg);
      print( "</td></tr></table>\n");
      print( "<br>\n");
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_cache_debug( $msg, $comment = '')
  {
    global $bh_cache_debug;

    if( $bh_cache_debug)
    {
      bh_debug( $msg, $comment);
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_panic( $msg)
  {
    die( '###!EOF ERROR: ' . $msg);    // meaning "end of playlist" for sc_trans
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_hit( $athing)
  {
    debug( "$athing as 'hit'");
  }

  // --------------------------------------------------------------------------

  function bh_set_uncached()
  {
    header( "Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header( "Last-modified: " . gmdate( "D, d M Y H:i:s") . " GMT");
    header( "Cache-Control: no-store, no-cache, must-revalidate");
    header( "Cache-Control: post-check=0, pre-check=0, false");
    header( "Pragma: no-cache");
  }


  // --------------------------------------------------------------------------

  function bh_unserialize_data( $data)
  {
    global $bh_ignore_json;

    if( function_exists( 'json_decode') && ! $bh_ignore_json)
    {
      return json_decode( $data);
    }
    else
    {
      return unserialize( $data);
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_cleanup( $input, $max_len)
  // sanitize input a bit, out with the tags and keep length within limits
  // and make it CSV friendly ... by escaping double quotes as double double
  // quotes.
  {

    $search = array(
      '@<script[^>]*?>.*?</script>@si',   // Strip out javascript
      '@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags
      '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
      '@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments
    );

    if( is_array( $input))
    {
      $result = '';
    }
    else
    {
      $result = preg_replace( $search, '', $input);
    }

    if( strlen( $result) > $max_len)
    {
      $result = substr( $result, 0, $max_len);
    }

    $result = str_replace( '"'  , '""', $result);
    $result = str_replace( "\\'", "'" , $result);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_read_param( $param_array, $key, $max_size, $default_value)
  {
    $result = array_key_exists( $key, $param_array) ? bh_cleanup( $param_array[ $key], $max_size) : $default_value;

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_read_get_param( $key, $max_size, $default_value)
  {
    $result = bh_read_param( $_GET, $key, $max_size, $default_value);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_read_post_param( $key, $max_size, $default_value)
  {
    $result = bh_read_param( $_POST, $key, $max_size, $default_value);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_is_comment( $line)
  {
    $pos = strpos( trim( $line), '//');
    if( $pos === false)
    {
      $result = false;
    }
    else if( $pos == 0)
    {
      $result = true;
    }
    else
    {
      $result = false;
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_deep_strip_quotes( $item)
  {
    $result = '';

    if( is_array( $item))
    {
      $result = array();
      foreach( $item as $sub_item)
      {
        $result[] = bh_deep_strip_quotes( $sub_item);
      }
    }
    else if( is_string( $item))
    {
      $result = trim( $item, "'\"");
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_parse_on( $separator, $string)
  {
    $result = array();

    $items = explode( $separator, $string);
    foreach( $items as $item)
    {
      $trimmed_item = trim( $item);
      if( $trimmed_item != "" && ! bh_is_comment( $trimmed_item))
      {
        $result[] = $trimmed_item;
      }
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_file_lines( $filename)
  {
    if( file_exists( $filename))
      $result = bh_parse_on( "\n", file_get_contents( $filename));
    else
      $result = array();

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_format_utc( $dt)
  {
    return date( "Y-m-d H:i:s", $dt);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_time( $time, $comment = '')
  {
    global $bh_use_time_debug;

    if( $bh_use_time_debug)
    {
      $date = bh_format_utc( $time);
      bh_debug( "show at $date :: $comment");
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_format_duration( $seconds)
  {
    $minutes = $seconds / 60;
    $seconds = $seconds % 60;
    $hours   = $minutes / 60;
    $minutes = $minutes % 60;

    $result = sprintf( "%02d:%02d:%02d", $hours, $minutes, $seconds);

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_setHMS( $time, $h, $m, $s)
  {
    $info   = getdate( $time);
    $result = mktime( $h, $m, $s, $info[ "mon"], $info[ "mday"], $info[ "year"]);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_setYMD( $time, $y, $m, $d)
  {
    $info   = getdate( $time);
    $result = mktime( $info[ "hours"], $info[ "minutes"], $info[ "seconds"], $m, $d, $y);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_asciiWeekDay( $aWeekDay)
  {
    if     ( $aWeekDay === 1) { return 'mon';}
    else if( $aWeekDay === 2) { return 'tue';}
    else if( $aWeekDay === 3) { return 'wed';}
    else if( $aWeekDay === 4) { return 'thu';}
    else if( $aWeekDay === 5) { return 'fri';}
    else if( $aWeekDay === 6) { return 'sat';}
    else if( $aWeekDay === 0) { return 'sun';}
    else                      { return '---';}
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_numericWeekDay( $aWeekDay)
  {
    if     ( $aWeekDay === 'mon') { return 1;}
    else if( $aWeekDay === 'tue') { return 2;}
    else if( $aWeekDay === 'wed') { return 3;}
    else if( $aWeekDay === 'thu') { return 4;}
    else if( $aWeekDay === 'fri') { return 5;}
    else if( $aWeekDay === 'sat') { return 6;}
 // else if( $aWeekDay === 'sun') { return 0;}
    else                          { return 0;}
  }


  function bh_numericWeekDayMask( $aWeekDay)
  {
    return 1 << bh_numericWeekDay( $aWeekDay);
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_getDOW( $aDate)
  {
    $info = getdate( $aDate);
    $wday = $info[ "wday"];
    return $wday;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dayInRange( $aDate, $aLowDay, $aHighDay)
  {
    $info   = getdate( $aDate);
    $mday   = $info[ "mday"];
    $result = ( $mday >= $aLowDay) && ( $mday <= $aHighDay);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek1( $aDate)
  {
    return bh_dayInRange( $aDate, 1, 7);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek2( $aDate)
  {
    return bh_dayInRange( $aDate, 8, 14);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek3( $aDate)
  {
    return bh_dayInRange( $aDate, 15, 21);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek4( $aDate)
  {
    return bh_dayInRange( $aDate, 22, 28);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek5( $aDate)
  {
    return bh_dayInRange( $aDate, 29, 31);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek1or3( $aDate)
  {
    return ( bh_dateIsInWeek1( $aDate) || bh_dateIsInWeek3( $aDate));
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_dateIsInWeek2or4( $aDate)
  {
    return ( bh_dateIsInWeek2( $aDate) || bh_dateIsInWeek4( $aDate));
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_locked_get_contents( $filename)
  {
    $result = false;

    if( file_exists( $filename))
    {
      $fp = fopen( $filename, 'r');
      if( flock( $fp, LOCK_SH | LOCK_NB))
      {
        $result = file_get_contents( $filename);
        flock( $fp, LOCK_UN);
        if( $result === false)
        {
          bh_cache_debug( "can not read file $filename but could lock it");
        }
      }
      else
      {
        bh_cache_debug( "can not obtain a lock on file $filename");
      }
      fclose( $fp);
    }
    else
    {
      bh_cache_debug( "file $filename does not exist, can not read it");
    }
    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_daily( $list, $count, $day, $dow, $mask, $showTime, $end, $currentTime, $remark)
  {
    global $bh_debug;

    if( $bh_debug)
    {
      $st = bh_format_utc( $showTime);
      $et = bh_format_utc( $end);
      $ct = bh_format_utc( $currentTime);

      print( "list     : $list<br>\n");
      print( "count    : $count<br>\n");
      print( "day      : $day<br>\n");
      print( "dow      : $dow<br>\n");
      print( "mask     : $mask<br>\n");
      print( "show time: $st, now: $ct<br>\n");
      print( "end  time: $et, now: $ct<br>\n");
      print( "^ $remark --------------------<br>\n");
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_makeStartTime( $list, $currentTime, $aWeekDay, $day_mask, $aScheduleType, $anAnchor, $aStartTime, $aDuration)
  {
    // Return the start time for the next show in GMT
    // Duration in seconds now

    global $bh_secondsInHour;
    global $bh_secondsInDay;
    global $bh_secondsInWeek;

    $showTime = $currentTime;                                         // Assume the show to be now
    bh_debug_time( $showTime, 'point 10 - set show time to now, schedule type = ' . $aScheduleType);

    $hr = (int) substr( $aStartTime, 0, 2);                           // Get actual UTC start time
    $mn = (int) substr( $aStartTime, 2, 2);

    // print( "hour = $hr, minute = $mn");

    $showTime = bh_setHMS( $showTime, $hr, $mn, 0);                   // And plug that in, assumes the show to be this day
    bh_debug_time( $showTime, 'point 20 - set to the correct hour');  // at the correct hour
    $showTime -= $bh_secondsInDay;                                    // Go back a Day
    bh_debug_time( $showTime, 'point 25, backed up a day');

    $aWeekDay = bh_numericWeekDay( $aWeekDay);

    if( $aScheduleType == 'daily')
    {
      // $showTime += $bh_secondsInDay;                                    // Do NOT go forward a day or so it seems
    }
    else
    {
      $count = 0;                                                       // Guard against invalid week days
      while( ( bh_getDOW( $showTime) != $aWeekDay) && ( $count++ < 10)) // while not on the correct weekday
      {
        $showTime += $bh_secondsInDay;                                  // Go forward a day
      }
    }

    bh_debug_time( $showTime, 'point 30 - set to correct weekday and time (but not date)');

    // We now have the show on the correct week day and at the correct time, but not a correct date yet
    // now sort out the schedule type

    if( $aScheduleType === "every other week")
    {
      // an anchor date is used
      //
      // anAnchor is supposed to hold the date of the first show ... we assume it
      // to be strictly in ISO date format.

      $yr = (int) substr( $anAnchor, 0, 4);
      $mt = (int) substr( $anAnchor, 5, 2);
      $dt = (int) substr( $anAnchor, 8, 2);

      $showTime = bh_setYMD( $showTime, $yr, $mt, $dt);               // Set time to anchor date

      bh_debug_time( $showTime, 'point 40 - synced to anchor date');

      $count = 0;
      while(                                                          // While smaller than now (in UTC)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 500) // Allow for 500 weeks ... over 9 years past anchor
      )
      {
        $showTime += 2 * $bh_secondsInWeek;                           // Repeatedly add two weeks, till future time reached
      }
    }

    else if( $aScheduleType === "once")
    {
      // an anchor date is used
      //
      // anAnchor is supposed to hold the right date ... we assume it
      // to be strictly in ISO date format
      //
      // todo: for a one off show ... once the item has passed it should
      // no longer be visible maybe ...

      $year  = (int) substr( $anAnchor, 0, 4);
      $month = (int) substr( $anAnchor, 5, 2);
      $day   = (int) substr( $anAnchor, 8, 2);

      $showTime = bh_setYMD( $showTime, $year, $month, $day);         // Set time to anchor date
    }

    else if( $aScheduleType === "week 1")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek1( $showTime)) && ( $count++ < 7))     // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 2")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) &&
        ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek2( $showTime)) && ( $count++ < 7))     // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 3")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek3( $showTime)) && ( $count++ < 7))     // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 4")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek4( $showTime)) && ( $count++ < 7))     // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 5")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek4( $showTime)) && ( $count++ < 7))     // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 1 and 3")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek1or3( $showTime)) && ( $count++ < 7))  // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "week 2 and 4")
    {
      // no anchor is needed, just search first suitable week
      $count = 0;
      while(                                                          // While smaller than now (in GMT)
        ( $showTime + $aDuration < $currentTime) && ( $count++ < 7)
      )
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
      $count = 0;
      while(( ! bh_dateIsInWeek2or4( $showTime)) && ( $count++ < 7))  // While not in correct week
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week
      }
    }

    else if( $aScheduleType === "daily")
    {
      // no anchor is needed and no time adjustments are needed, every unmasked day is suitable
      $count = 0;

      // bh_debug( "-------------- new daily item ----------", "list = $list");

      $day  = bh_getDOW( $showTime);
      $dow  = bh_asciiWeekDay( $day);
      $mask = $day_mask[ ( $day + 6) % 7];                            // convert from mon = 1 to mon = 0
      $end  = $showTime + $aDuration;

      //bh_debug_daily( $list, $count, $day, $dow, $mask, $showTime, $end, $currentTime, 'before');

      while(
        ( $end < $currentTime) &&                                     // While smaller than now (in GMT)
        ( $mask != '1') &&                                            // and show time not in day_mask
        ( $count++ < 9)
      )
      {
        $showTime += $bh_secondsInDay;                                // Repeatedly add a day, till future time reached

        $day  = bh_getDOW( $showTime);
        $dow  = bh_asciiWeekDay( $day);
        $mask = $day_mask[ ( $day + 6) % 7];
        $end  = $showTime + $aDuration;

        // bh_debug_daily( $list, $count, $day, $dow, $mask, $showTime, $end, $currentTime, 'added one day');
      }

      if(( $end < $currentTime) || ( $mask != '1'))
      {
        $showTime += $bh_secondsInDay;                                // Repeatedly add a day, till next future scheduled time reached

        $day  = bh_getDOW( $showTime);
        $dow  = bh_asciiWeekDay( $day);
        $mask = $day_mask[ ( $day + 6) % 7];
        $end  = $showTime + $aDuration;

        // bh_debug_daily( $list, $count, $day, $dow, $mask, $showTime, $end, $currentTime, '** next day');

        while(
          (
            ( $end < $currentTime) ||                                   // While smaller than now (in GMT)
            ( $mask != '1')                                             // and show time not in day_mask
          ) &&
          ( $count++ < 9)
        )
        {
          $showTime += $bh_secondsInDay;                              // Repeatedly add a day, till next future scheduled time reached

          $day  = bh_getDOW( $showTime);
          $dow  = bh_asciiWeekDay( $day);
          $mask = $day_mask[ ( $day + 6) % 7];
          $end  = $showTime + $aDuration;

          // bh_debug_daily( $list, $count, $day, $dow, $mask, $showTime, $end, $currentTime, '** added one day');
        }
      }
      // bh_debug( '-------------- end daily item ----------', "list = $list");
    }

    else // "weekly"
    {
      // no anchor is needed and no time adjustments are needed, every week is suitable
      $count = 0;
      while( ( $showTime + $aDuration < $currentTime) && ( $count++ < 14)) // While smaller than now (in GMT)
      {
        $showTime += $bh_secondsInWeek;                               // Repeatedly add a week, till future time reached
      }
    }

    bh_debug_time( $showTime, 'point 50 - calculated next show time');

    return $showTime;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_load_playlists( $playlists_dir, $cleanit = true)
  {
    $result = array();

    if( is_dir( $playlists_dir . '/'))
    {
      if( $handle = opendir( $playlists_dir))
      {
        while( false !== ( $name = readdir( $handle)))
        {
          if( $name != "." && $name != "..")
          {
            if( is_dir( $playlists_dir . "/" . $name) === true)
            {
              // echo "DIRECTORY: ".$name."\n";
            }
            else
            {
              // echo "FILE: " . $name."\n";
              $parts = bh_parse_on( '.', $name);              // Check if file has an extension
              $count = count( $parts);
              if( $count > 1)                                 // if it has there are two parts at least
              {
                if( $parts[ $count - 1] == 'lst')             // playlist extension must be .lst
                {
                  if( strlen( $name) > 1)                     // name must always have one character at least
                  {
                    if( ! $cleanit || $name[ 0] != '_')       // if cleaning skip files starting with _ char
                    {
                      $parts = bh_parse_on( '_', $name);      // also skip playlists of form playlist_xxx
                      $count = count( $parts);
                      if( ! ( $cleanit && $count == 2 && $parts[ 0] == 'playlist'))
                      {
                        $fn             = $playlists_dir . "/" . $name;
                        $data           = bh_get_file_lines( $fn);
                        $result[ $name] = array( 'file_name' => $fn, 'data' => $data);
                      }
                    }
                  }
                }
              }
            }
          }
        }
        closedir( $handle);
      }
      else
      {
        bh_panic( 'can not open playlists folder');
      }
    }
    else
    {
      bh_panic( 'no playlists folder');
    }

    ksort( $result);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_time()
  {
    global $bh_time_offset;

    $result = time() + $bh_time_offset;

    if( $result < 0)
      $result = 0;

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_load_schedule( $schedule_file)
  {
    $result = array();
    $now    = bh_time();

    // bh_debug( $schedule_file);

    if( file_exists( $schedule_file))
    {
      $lines = bh_get_file_lines( $schedule_file);

      // bh_debug( $lines);

      foreach( $lines as $line)
      {
        $items = bh_parse_on( ',', $line); // bh_debug( $items);
        $items = bh_deep_strip_quotes( $items);
        $count = count( $items);

        if( $count == 3 && $items[ 0] == 'default')
        {
          // bh_debug( $items);
          $result[] = array( 'default_author'  => $items[ 1], 'default_file' => $items[ 2]);
        }
        if( $count == 3 && $items[ 0] == 'filler')
        {
          // bh_debug( $items);
          $result[] = array( 'filler_author'  => $items[ 1], 'filler_file' => $items[ 2]);
        }
        else if( $count == 9)
        {
          $result[] = array(
            'visible'    => $items[  0],
            'playable'   => $items[  1],
            'day'        => $items[  2],
            'type'       => $items[  3],
            'anchor'     => $items[  4],
            'start'      => $items[  5],
            'duration'   => $items[  6],
            'author'     => $items[  7],
            'file'       => $items[  8],
            'auto_reset' => 'off',
            'day_mask'   => '1111111'
          );
        }
        else if( $count == 10)
        {
          $result[] = array(
            'visible'    => $items[  0],
            'playable'   => $items[  1],
            'day'        => $items[  2],
            'type'       => $items[  3],
            'anchor'     => $items[  4],
            'start'      => $items[  5],
            'duration'   => $items[  6],
            'author'     => $items[  7],
            'file'       => $items[  8],
            'auto_reset' => $items[  9],
            'day_mask'   => '1111111'
          );
        }
        else if( $count == 11)
        {
          $result[] = array(
            'visible'    => $items[  0],
            'playable'   => $items[  1],
            'day'        => $items[  2],
            'type'       => $items[  3],
            'anchor'     => $items[  4],
            'start'      => $items[  5],
            'duration'   => $items[  6],
            'author'     => $items[  7],
            'file'       => $items[  8],
            'auto_reset' => $items[  9],
            'day_mask'   => $items[ 10]
          );
        }
      }
    }
    else
    {
      bh_panic( 'schedule file not found');
    }

    return( $result);
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_same_sched( $sched1, $sched2)
  {
    $result =
   // $sched1[ 'start_time'  ] == $sched2[ 'start_time'  ]  &&
      $sched1[ 'duration'    ] == $sched2[ 'duration'    ]  &&
   // $sched1[ 'is_live'     ] == $sched2[ 'is_live'     ]  &&
      $sched1[ 'year'        ] == $sched2[ 'year'        ]  &&
      $sched1[ 'month'       ] == $sched2[ 'month'       ]  &&
      $sched1[ 'mday'        ] == $sched2[ 'mday'        ]  &&
      $sched1[ 'hours'       ] == $sched2[ 'hours'       ]  &&
      $sched1[ 'minutes'     ] == $sched2[ 'minutes'     ]  &&
      $sched1[ 'author'      ] == $sched2[ 'author'      ]  &&
      $sched1[ 'file'        ] == $sched2[ 'file'        ]  &&
      $sched1[ 'is_default'  ] == $sched2[ 'is_default'  ]  &&
      $sched1[ 'is_filler'   ] == $sched2[ 'is_filler'   ]  &&
      $sched1[ 'playtime'    ] == $sched2[ 'playtime'    ]  &&
      $sched1[ 'auto_reset'  ] == $sched2[ 'auto_reset'  ]  &&
      $sched1[ 'day_mask'    ] == $sched2[ 'day_mask'    ]  &&
   // $sched1[ 'song_pointer'] == $sched2[ 'song_pointer']  &&
      $sched1[ 'song_count'  ] == $sched2[ 'song_count'  ];

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_fix_song_pointer( &$song_pointer, &$sched, $song_count, $list_name)
  {
    global $bh_playlist_pointers;

    if( $song_pointer < 0 || $song_pointer >= $song_count)
    {
      $song_pointer = 0;
    }
    $sched[ 'song_pointer']            = $song_pointer;
    $bh_playlist_pointers[ $list_name] = $song_pointer;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_advance_song_pointer( &$song_pointer, &$sched, $song_count, $list_name)
  {
    $song_pointer++;
    bh_fix_song_pointer( $song_pointer, $sched, $song_count, $list_name);
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_load_song_cache( $filename)
  {
    $cache = bh_locked_get_contents( $filename);           // Try to read the cache file

    if( $cache === false)
    {
      bh_panic( "song cache read failed, can not go on without it ...");
    }
    else
    {
      bh_cache_debug( "cache read ok, going on ...");
    }

    // We eiiter paniced or haved some file's contents now, let's see

    $result = bh_unserialize_data( $cache);

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_load_last_playlist()
  {
    global $bh_last_list_fn;

    $result = '';

    if( file_exists( $bh_last_list_fn))
    {

      $lines = bh_parse_on( "\n", file_get_contents( $bh_last_list_fn));

      if( count( $lines) > 0)
      {
        $result = $lines[ 0];
      }
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_save_last_playlist( $last_list)
  {
    global $bh_last_list_fn;

    file_put_contents( $bh_last_list_fn, $last_list);
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_clean_song_name( $song_file_name)
  {
    $file_parts = bh_parse_on( '/', $song_file_name);
    $result     = $file_parts[ count( $file_parts) - 1];

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_song_playtime( $song_file_name, $cache, $list_file_nm = 'no list info')
  {
    $result = 0.0;

    // bh_debug( $song_file_name);

    $clean_name = bh_get_clean_song_name( $song_file_name);

    if( array_key_exists( $clean_name, $cache))
    {
      $file_info = $cache[ $clean_name];  // bh_debug( $file_info, 'file info');
      if( array_key_exists( 'playtime', $file_info))
      {
        $result += $file_info[ 'playtime'];
      }
      else
      {
        bh_debug( "WARNING: no cached duration for song '$song_file_name' in playlist '$list_file_nm'");
      }
    }
    else
    {
      bh_debug( "WARNING: no cached file info for song '$song_file_name' in playlist '$list_file_nm'");
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_list_playtime( $listname, $playlists, &$cache)
  {
    $result = 0.0;

    if( array_key_exists( $listname, $playlists))
    {
      $playlist = $playlists[ $listname];               // bh_debug( $playlist, 'playlist');

      // if( array_key_exists( ''))

      if( array_key_exists( 'data', $playlist))
      {
        $files        = $playlist[ 'data'     ];        // bh_debug( $files       , 'files'             );
        $list_file_nm = $playlist[ 'file_name'];        // bh_debug( $list_file_nm, 'playlist file name');

        foreach( $files as $file)
        {
          $result += bh_get_song_playtime( $file, $cache, $list_file_nm);
        }
      }
      else
      {
        bh_debug( "WARNING: no 'data' item in playlist $listname");
      }
    }
    else
    {
      bh_debug( "WARNING: no '$listname' item in playlists");
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_load_playlist_pointers( $filename)
  {
    $result = array();

    $lines  = bh_get_file_lines( $filename);

    foreach( $lines as $line)
    {
      $fields = bh_parse_on( '=', $line);
      if( count( $fields) == 1)
      {
        $result[ $fields[ 0]] = 0;
      }
      if( count( $fields) == 2)
      {
        $result[ $fields[ 0]] = $fields[ 1];
      }
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_save_playlist_pointers( $filename, $pointers)
  {
    $lines  = bh_get_file_lines( $filename);
    $output = array();

    if( is_array( $pointers))
    {
      foreach( $pointers as $key => $value)
      {
        if( $value == '')
          $output[] = "$key=0";
        else
          $output[] = "$key=$value";
      }
      $output = implode( "\n", $output);
      file_put_contents( $filename, $output);
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_song_count( $playlists, $listname)
  {
    $result = 0;

    if( array_key_exists( $listname, $playlists))
    {
      $result = count( $playlists[ $listname][ 'data']);
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_get_playlist_pointer( $playlist_pointers, $file)
  {
    if( array_key_exists( $file, $playlist_pointers))
      $result = $playlist_pointers[ $file];
    else
      $result = 0;

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_set_playlist_pointer( &$playlist_pointers, $file, $value)
  {
    $playlist_pointers[ $file] = $value;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_sched_is_live_at_time( $sched, $time)
  {
    $result =
      ( $time >=   $sched[ 'start_time']                       ) &&
      ( $time <= ( $sched[ 'start_time'] + $sched[ 'duration']));

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_schedule_find_first_live_at_time( $schedule, $time)
  {
    $result = NULL;

    foreach( $schedule as $sched)
    {
      if( bh_sched_is_live_at_time( $sched, $time))
      {
        $result = $sched;
        break;
      }
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_sched_goes_over_time( $sched, $time)
  {
    $result = $time >= $sched[ 'start_time'];

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_schedule_find_first_over_time( $schedule, $time)
  {
    $result = NULL;

    foreach( $schedule as $sched)
    {
      if( bh_sched_goes_over_time( $sched, $time))
      {
        $result = $sched;
        break;
      }
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_collect_songs( $cache, $playlist_info, $playlists, $gap_time, $wanted_song_count, $song_pointer)
  {
    // when $song_pointer is -1 collect random songs till the gap is filled 'precisely'
    // otherwise collect the first $wanted_song_count items starting at $song_pointer

    $result     = array();
    $songs      = $playlist_info[ 'data'];
    $song_count = count( $songs);
    if( $song_pointer == - 1)
    {
      $accu_time = 0;
      $done      = false;
      $count     = 0;
      $tries     = 0;

      while( !$done && ( $tries++ < 10000))
      {
        $i    = mt_rand( 0, $song_count - 1);
        $song = $songs[ $i];
        $time = bh_get_song_playtime( $song, $cache);
        if( $accu_time + $time < $gap_time)
        {
          $result[]   = $song;
          $accu_time += $time;
          $count++;
          $done = $count >= $wanted_song_count;
        }
      }
    }
    else
    {
      for( $i = 0; $i < $wanted_song_count; $i++)
      {
        $result[] = $songs[ $song_pointer];
        $song_pointer = ( $song_pointer + 1) % $song_count;
      }
    }

    return $result;
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_validate_anchor( $anchor, $wday)
  {
    $result = false;

    if( strlen( $anchor) == 1)
    {
      $result = true;
    }
    else if( strlen( $anchor) == 10)
    {
      $year  = substr( $anchor, 0, 4);
      $month = substr( $anchor, 5, 2);
      $mday  = substr( $anchor, 8, 2);

      if(
        is_numeric( $year )              &&
        ( $year > 2010)                  &&  // past years make no sense here
        ( $year < 2038)                  &&  // Dont go beyond 32 bit unsigned valid unix dates
        is_numeric( $month)              &&
        is_numeric( $mday  )             &&
        checkdate( $month, $mday, $year)
      )
      {
        $date = mktime( 0, 0, 0, $month, $mday, $year);
        $wday = bh_numericWeekDay( $wday);
        $dayw = bh_getDOW( $date);
        if( $wday == $dayw)
        {
          $result = true;
        }
        else
        {
          debug( "specified wday $wday does not match dayw $dayw as calculated from anchor $anchor, invalid DOW specified for valid date");
          $result = true;
        }
      }
      else
      {
        if( !is_numeric( $year ))
        {
          debug( "year $year not numeric");
        }
        if( !( $year > 2010))
        {
          debug( "year $year <= 2010");
        }
        if( !( $year < 2038))
        {
          debug( "year $year >= 2038");
        }
        if( !is_numeric( $month ))
        {
          debug( "month $month not numeric");
        }
        if( !is_numeric( $mday ))
        {
          debug( "mday $mday not numeric");
        }
        if( !checkdate( $month, $mday, $year))
        {
          debug( "year month mday $year $month $mday is not a valid date");
        }
        debug( 'date check fails');
        $result = false;
      }
    }
    else
    {
      $result = false;
    }

    return $result;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_sched( $sched)
  {
    global $bh_debug;
    global $bh_time_offset;

    if( $bh_debug)
    {
      print( "<p><u>playlist schedule item</u></p>\n");
      print( "<table><tbody>\n");

      print( "<tr>");
      print( "<td>start_time (unix)         </td>");
      print( "<td>duration (s)              </td>");
      print( "<td>year                      </td>");
      print( "<td>month                     </td>");
      print( "<td>mday                      </td>");
      print( "<td>hours                     </td>");
      print( "<td>minutes                   </td>");
      print( "<td>author                    </td>");
      print( "<td>file                      </td>");
      print( "<td>playtime (s)              </td>");
      print( "<td>day_mask (first is mon)   </td>");
      print( "<td>song_pointer (0 relative) </td>");
      print( "<td>song_count                </td>");
      print( "<td>auto_reset                </td>");
      print( "<td>is_live                   </td>");
      print( "<td>is_default                </td>");
      print( "<td>is_filler                 </td>");
      print( "</tr>\n");

      $start_time   = bh_format_utc(      $sched[ "start_time"] - $bh_time_offset);
      $duration     = bh_format_duration( $sched[ "duration"  ]);
      $year         = $sched[ "year"         ];
      $month        = $sched[ "month"        ];
      $mday         = $sched[ "mday"         ];
      $hours        = $sched[ "hours"        ];
      $minutes      = $sched[ "minutes"      ];
      $author       = $sched[ "author"       ];
      $file         = $sched[ "file"         ];
      $playtime     = bh_format_duration( $sched[ "playtime"  ]);
      $day_mask     = $sched[ 'day_mask'     ];
      $song_pointer = $sched[ "song_pointer" ];
      $song_count   = $sched[ "song_count"   ];
      $auto_reset   = $sched[ 'auto_reset'   ];
      $is_live      = $sched[ "is_live"      ];
      $is_default   = $sched[ "is_default"   ];
      $is_filler    = $sched[ "is_filler"    ];

      print( "<tr>");
      print( "<td>$start_time  </td>");
      print( "<td>$duration    </td>");
      print( "<td>$year        </td>");
      print( "<td>$month       </td>");
      print( "<td>$mday        </td>");
      print( "<td>$hours       </td>");
      print( "<td>$minutes     </td>");
      print( "<td>$author      </td>");
      print( "<td>$file        </td>");
      print( "<td>$playtime    </td>");
      print( "<td>$day_mask    </td>");
      print( "<td>$song_pointer</td>");
      print( "<td>$song_count  </td>");
      print( "<td>$auto_reset  </td>");
      print( "<td>$is_live     </td>");
      print( "<td>$is_default  </td>");
      print( "<td>$is_filler   </td>");
      print( "</tr>\n");

      print( "</tbody></table>\n");
    }
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_schedule( $schedule)
  {
    global $bh_debug;
    global $bh_time_offset;

    if( $bh_debug)
    {
      print( "<p><u>playlist schedule</u></p>\n");
      print( "<table><tbody>\n");

      print( "<tr>");
      print( "<td>start_time (unix)         </td>");
      print( "<td>duration (s)              </td>");
      print( "<td>year                      </td>");
      print( "<td>month                     </td>");
      print( "<td>mday                      </td>");
      print( "<td>hours                     </td>");
      print( "<td>minutes                   </td>");
      print( "<td>author                    </td>");
      print( "<td>file                      </td>");
      print( "<td>playtime (s)              </td>");
      print( "<td>day_mask (first is mon)   </td>");
      print( "<td>song_pointer (0 relative) </td>");
      print( "<td>song_count                </td>");
      print( "<td>auto_reset                </td>");
      print( "<td>is_live                   </td>");
      print( "<td>is_default                </td>");
      print( "<td>is_filler                 </td>");
      print( "</tr>\n");

      foreach( $schedule as $sched)
      {
        $start_time   = bh_format_utc(      $sched[ "start_time"] - $bh_time_offset);
        $duration     = bh_format_duration( $sched[ "duration"  ]);
        $year         = $sched[ "year"         ];
        $month        = $sched[ "month"        ];
        $mday         = $sched[ "mday"         ];
        $hours        = $sched[ "hours"        ];
        $minutes      = $sched[ "minutes"      ];
        $author       = $sched[ "author"       ];
        $file         = $sched[ "file"         ];
        $playtime     = bh_format_duration( $sched[ "playtime"  ]);
        $day_mask     = $sched[ 'day_mask'     ];
        $song_pointer = $sched[ "song_pointer" ];
        $song_count   = $sched[ "song_count"   ];
        $auto_reset   = $sched[ 'auto_reset'   ];
        $is_live      = $sched[ "is_live"      ];
        $is_default   = $sched[ "is_default"   ];
        $is_filler    = $sched[ "is_filler"    ];

        print( "<tr>");
        print( "<td>$start_time  </td>");
        print( "<td>$duration    </td>");
        print( "<td>$year        </td>");
        print( "<td>$month       </td>");
        print( "<td>$mday        </td>");
        print( "<td>$hours       </td>");
        print( "<td>$minutes     </td>");
        print( "<td>$author      </td>");
        print( "<td>$file        </td>");
        print( "<td>$playtime    </td>");
        print( "<td>$day_mask    </td>");
        print( "<td>$song_pointer</td>");
        print( "<td>$song_count  </td>");
        print( "<td>$auto_reset  </td>");
        print( "<td>$is_live     </td>");
        print( "<td>$is_default  </td>");
        print( "<td>$is_filler   </td>");
        print( "</tr>\n");
      }
      print( "</tbody></table>\n");
    }
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_playlist( $list, $name)
  {
    global $bh_debug;

    if( $bh_debug)
    {
      $filename = $list[ 'file_name'];
      $files    = $list[ 'data'     ];

      print( "<p>playlist '$name'</p>\n");

      // bh_debug( $list);

      print( "<table><tbody>\n");

      print( "<tr><td>file name</td><td>'$filename'</td></tr>\n");

      $i = 0;
      $data = $list[ 'data'];

      foreach( $data as $song)
      {
        $i++;

        print( "<tr><td>song $i</td><td>'$song'</td></tr>\n");
      }
      print( "</tbody></table>\n");
    }
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function bh_debug_playlists( $playlists)
  {
    global $bh_debug;

    if( $bh_debug)
    {
      print( "<p><u>playlists</u> (all found in playlists directory)</p>\n");

      foreach( $playlists as $name => $data)
      {
        bh_debug_playlist( $data, $name);
      }
    }
  }



?>
